/**

Camarero

Adems los camareros de la fiesta ofrecern comida y bebida a 
todas las personas invitadas y al anfitrin de la fiesta.

Como extra al trabajo, se podra aadir informacin de lo que ha 
comido y bebido cada uno y de todo lo que han trabajado los camareros.

**/

package actores.behaviours;

import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*; 
import java.io.*;
import java.util.*;
import java.util.Random;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;


import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.core.behaviours.TickerBehaviour;




public class Camarero extends Agent
{
	int quienSoy ;
	
	ArrayList<String> menu = new ArrayList<String>();
	
	//Lo que ha servido cada camarero en general
	ArrayList<String> canapesServidos = new ArrayList<String>();
	HashMap<String, Integer > comerbeberServido = new HashMap<String, Integer>();
	
	//Y a quien
	ArrayList<String> personasServidas = new ArrayList<String>();
	
	
	

	Random randomGenerator ;


	protected void setup()
	{	
		
		
		
		if( getLocalName().substring(8).equals("1") )
		{
			quienSoy = 0 ;
		}
		else if( getLocalName().substring(8).equals("2") )
		{
			quienSoy = 1;
		}		
		else
		{
			quienSoy = 2 ;
		}
		
		//esperando un mensaje REQUEST para desbloquear al actor
		
		final ACLMessage msg = blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.REQUEST));
		
		DFAgentDescription listadoInvitados = new DFAgentDescription();
		listadoInvitados.setName( getAID() );
		ServiceDescription sd = new ServiceDescription();
		sd.setType("party-camarero");
		sd.setName( getLocalName() );
		listadoInvitados.addServices( sd );
		try 
		{
		  DFService.register(this, listadoInvitados);
		}
		catch (FIPAException fe) 
		{
		  fe.printStackTrace();
		}	
		
		
		
		addBehaviour( new esperarMenu() );	
		addBehaviour( new atenderInvitado() );
		addBehaviour( new servirComida() );
		addBehaviour( new huir() );
		
	}//fin setup()

	
	/** Periodicamente se ofrecera comida la gente que esta en la fiesta **/
	private class servirComida extends CyclicBehaviour 
	{
	
		public void action() 
		{ 
			MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.AGREE);
			ACLMessage mensaje = myAgent.receive(mt);
		  
			if (mensaje != null)
			{
			
					try
					{												
						
						int conta = 0 ;
						
						ArrayList<String> personas = new ArrayList<String>();						
						personas = (ArrayList<String>) mensaje.getContentObject();		
						
						
						for ( int i = 0 ; i < personas.size() &&  personas.get(i) != null ; i++ )
						{
							
							if ( ( i+1) % 3 == quienSoy &&  personas.get(i) != null)
							{
								String bebida ;
								
								randomGenerator = new Random();				
								int ran = randomGenerator.nextInt(20); //canape
								
								randomGenerator = new Random();				
								int ran2 = randomGenerator.nextInt(2);//bebida
								
										
								if ( ran2  == 0 ) 	bebida = "Champagne Moet & Chandon" ;
								else				bebida = "Chateau Lafite Rothschild Imperial 1982";
								
								
								System.out.println( "[" + getLocalName() +"] le sirve a " +  personas.get(i) + " una copa de " + bebida + " y un canape , " +  menu.get(ran) );
								
								
								
								//Primero aado al arrayList
								if ( !canapesServidos.contains( bebida) )		
									canapesServidos.add( bebida ) ;
								
								if ( !canapesServidos.contains( menu.get(ran) ) )		
									canapesServidos.add( menu.get(ran) ) ;
								
								//A continuacion a la tabla Hash
								if ( !comerbeberServido.containsKey( bebida ) )
									comerbeberServido.put( bebida , 1 ) ;
								else
									comerbeberServido.put( bebida , comerbeberServido.get("Champagne Moet & Chandon") + 1 ) ;
									
								if ( !comerbeberServido.containsKey( menu.get(ran) ) )
									comerbeberServido.put( menu.get(ran) , 1 ) ;
								else
									comerbeberServido.put( menu.get(ran) , comerbeberServido.get( menu.get(ran) ) + 1 ) ;
														
							}
						
						}
					}
					catch(Exception e)
					{
						e.printStackTrace(); 
					}							
			}
			else
			{
				block();
			}
		}
	  
	}  // Fin servirComida
	
	/** esperamos que el coordinador nos envie el menu**/
	private class esperarMenu extends CyclicBehaviour 
	{
	
		public void action() 
		{ 
			MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
			ACLMessage mensaje = myAgent.receive(mt);
		  
			if (mensaje != null)
			{			
				try
				{										
					System.out.println("\n["+getLocalName() +"] Menu recibido de ...." + mensaje.getSender().getLocalName());
					menu = (ArrayList<String>) mensaje.getContentObject();						
				}	
				catch(Exception e)
				{
					e.printStackTrace(); 
				}							
			}
			else
			{
				block();
			}
		}
	  
	}  // Fin esperarMenu
	
	
	/** la primera vez que se le atiende en la fiesta al ser presentado por el coordinador **/
	private class atenderInvitado extends CyclicBehaviour 
	{
	
		boolean atendido = false ;
		
		public void action() 
		{
			MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.REQUEST);
			ACLMessage mensaje = myAgent.receive(mt);
		  
			if (mensaje != null && !atendido)
			{
				try
				{
									
					
					Random randomGenerator = new Random();				
					int ran = randomGenerator.nextInt(20);
					
					System.out.println("[" + getLocalName() +"] le sirve " +  mensaje.getContent() + " una copa de Champagne Moet & Chandon y un canape , " +  menu.get(ran)  );

					
					//Primero aado al arrayList
					if ( !canapesServidos.contains("Champagne Moet & Chandon") )		
						canapesServidos.add("Champagne Moet & Chandon");
					
					if ( !canapesServidos.contains( menu.get(ran) ) )		
						canapesServidos.add( menu.get(ran) );
					
					
					if ( !personasServidas.contains( mensaje.getContent() ) )		
						personasServidas.add( mensaje.getContent() );
					
					
					//A continuacion a la tabla Hash
					if ( !comerbeberServido.containsKey("Champagne Moet & Chandon") )
						comerbeberServido.put( "Champagne Moet & Chandon" , 1 ) ;
					else
						comerbeberServido.put( "Champagne Moet & Chandon" , comerbeberServido.get("Champagne Moet & Chandon") + 1 ) ;
						
					if ( !comerbeberServido.containsKey( menu.get(ran) ) )
						comerbeberServido.put( menu.get(ran) , 1 ) ;
					else
						comerbeberServido.put( menu.get(ran) , comerbeberServido.get( menu.get(ran) ) + 1 ) ;
											
					
					atendido = true ;
									
					
				}			
				catch (Exception ex) 
				{ 
					ex.printStackTrace(); 
				}
				
			}
			else
			{
				block();
			}
		}	
	  
	}  // Fin atenderInvitado
	
	/**nos chivan que va a haber un tiroteo y nos marchamos **/
	private class huir extends CyclicBehaviour 
	{
	
		public void action() 
		{ 
			MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.REFUSE);
			ACLMessage mensaje = myAgent.receive(mt);
		  
			if (mensaje != null)
			{			
				doDelete();		
			}
			else
			{
				block();
			}
		}
	  
	}  // Fin huir
	
	
	
	protected void takeDown()
	{
		
		
		/**
		// Lo que ha servido cada camarero en general
		ArrayList<String> canapesServidos = new ArrayList<String>();
		HashMap<String, Integer > comerbeberServido = new HashMap<String, Integer>();
	
		// Y a quien
		ArrayList<String> personasServidas = new ArrayList<String>();
		**/
		System.out.println("[" + getLocalName() + "] ha servido lo siguiente:" );
		for( int i = 0 ; i < canapesServidos.size() ; i ++ )
		{
			System.out.println("[" + getLocalName() + "] " + canapesServidos.get(i) + " : " + comerbeberServido.get( canapesServidos.get(i) ) );
		
		}
		
		// System.out.println("[" + getLocalName() + "] ha servido a los siguientes mafiosos:" );
				// for( int i = 0 ; i < personasServidas.size() ; i ++ )
		// {
			// System.out.println("[" + getLocalName() + "] " + personasServidas.get(i) ) ;
		
		// }
		
		
		System.out.println("\n[" + getLocalName() + "] abandona la fiesta por orden de su jefe.\n");
	}//fin takeDown()
	
}//fin Camarero